local class = require 'middleclass'

Architect = class('Architect')

function Architect:initialize()
	self.time = 0
	self.timeToNextSpawn = 6.5
end

function Architect:update(dt)
	self.time = self.time + dt
	self.timeToNextSpawn = self.timeToNextSpawn - dt

	local e = 2.71838182846

	if self.timeToNextSpawn < 0 then
		local spawns = 1
		if math.random() > 0.84 and self.time > 15 then
			spawns = 2
		end

		for _=1, spawns do
			local result = math.random()
			local angle = math.random() * 2 * math.pi
			local x = 320 * math.cos(angle)
			local y = 320 * math.sin(angle)

			if result < 0.5 then
				enemies:add(Tiny:new(x, y))
			elseif result < 0.7 then
				enemies:add(Sapper:new(x, y))
			elseif result < 0.9 then
				enemies:add(Bomber:new(x, y))
			else
				if self.time > 37 then
					enemies:add(Orbiter:new(x, y))
				else
					enemies:add(Tiny:new(x, y))
				end
			end
		end
		self.timeToNextSpawn = 3.2*e^(-0.024 * self.time) + 0.5 + math.random()*0.7
	end
end