local class = require 'middleclass'

Bomber = class('Bomber')

function Bomber:initialize(x, y)
	self.x = x
	self.y = y

	self.size = 14
	self.speed = 20 + math.random(20)
	local dx = cell.x - self.x
	local dy = cell.y - self.y
	local d = math.sqrt(dx^2 + dy^2)
	self.vx = dx * self.speed / d
	self.vy = dy * self.speed / d

	self.hp = 30
	self.dmg = 15

	self.rot = math.random() * math.pi
	self.rv = math.random() * math.pi

	self.toDelete = false
end

function Bomber:update(dt)
	local dx = cell.x - self.x
	local dy = cell.y - self.y
	local d = math.sqrt(dx^2 + dy^2)
	self.vx = dx * self.speed / d
	self.vy = dy * self.speed / d

	self.x = self.x + self.vx * dt
	self.y = self.y + self.vy * dt
	self.rot = self.rot + self.rv * dt

	if math.sqrt((cell.x - self.x)^2 + (cell.y - self.y)^2) < cell.size + self.size then
		self.toDelete = true
		cell.hp = cell.hp - self.dmg
		hurt2:rewind()
		hurt2:play()
		cameraShaking = true
		cameraShakeLength = cameraShakeLength + 0.5
		cameraShakeAmplitude = cameraShakeAmplitude + 10
	end

	if self.hp <= 0 then
		self.toDelete = true
		hurt2:rewind()
		hurt2:play()
		score = score + 60
	end
end

function Bomber:draw()
	love.graphics.setColor(30, 38, 37)
	love.graphics.draw(bomberImg, self.x, self.y, self.rot, 1, 1, 16, 16)
end