local class = require 'middleclass'

Bullet = class('Bullet')

function Bullet:initialize(x, y, vx, vy, size, slo, dmg)
	self.x = x
	self.y = y
	self.vx = vx
	self.vy = vy
	self.size = size
	self.slo = slo
	self.dmg = dmg

	self.toDelete = false
	self.maxLifetime = 5
	self.lifetime = 0
end

function Bullet:update(dt)
	self.x = self.x + self.vx * dt
	self.y = self.y + self.vy * dt

	for i=#enemies.contents, 1, -1 do
		if math.sqrt((self.x - enemies.contents[i].x)^2 + (self.y - enemies.contents[i].y)^2) <= self.size + enemies.contents[i].size then
			enemies.contents[i].hp = enemies.contents[i].hp - self.dmg
			enemies.contents[i].speed = enemies.contents[i].speed * self.slo
			self.toDelete = true
		end
	end

	self.lifetime = self.lifetime + dt
	if self.lifetime > self.maxLifetime then
		self.toDelete = true
	end
end

function Bullet:draw()
	--love.graphics.circle('fill', self.x, self.y, self.size)
	love.graphics.setColor(255, 255, 255)
	if self.slo ~= 1 then
		love.graphics.circle('fill', self.x, self.y, self.size)
		love.graphics.setColor(255, 255, 255, 120)
		love.graphics.circle('fill', self.x - self.vx*2/60, self.y - self.vy*2/60, self.size)
		love.graphics.setColor(255, 255, 255, 40)
		love.graphics.circle('fill', self.x - self.vx*4/60, self.y - self.vy*4/60, self.size)

	else
		love.graphics.draw(bulletImg, self.x, self.y, math.atan2(self.vy, self.vx), 1, 1, bulletImg:getWidth()/2, bulletImg:getHeight()/2)
	end
end