local class = require 'middleclass'

Button = class('Button')

function Button:initialize(x, y, w, h, text, onPress)
	self.x = x
	self.y = y
	self.w = w
	self.h = h

	self.text = text

	self.onPress = onPress
	self.hover = false
end

function Button:update(dt)
	local x = (love.mouse.getX() - offsetX) / maxScale
	local y = (love.mouse.getY() - offsetY) / maxScale
	self.hover = x > self.x and x < self.x + self.w and y > self.y and y < self.y + self.h 

	if self.hover and love.mouse.isDown('l') then
		self.onPress()
	end
end

function Button:draw()
	love.graphics.setColor(255, 255, 255)
	love.graphics.setFont(smallFont)
	love.graphics.print(self.text, self.x, self.y)
	if self.hover then
		love.graphics.draw(sapperImg, self.x - 14, self.y + self.h/2, 0, 1, 1, 16, 16)
	end
end