local class = require 'middleclass'

EnemyBullet = class('Bullet')

function EnemyBullet:initialize(x, y, vx, vy, size, slo, dmg)
	self.x = x
	self.y = y
	self.vx = vx
	self.vy = vy
	self.size = size
	self.slo = slo
	self.dmg = dmg

	self.toDelete = false
end

function EnemyBullet:update(dt)
	self.x = self.x + self.vx * dt
	self.y = self.y + self.vy * dt

	if math.sqrt((self.x - cell.x)^2 + (self.y - cell.y)^2) <= self.size + cell.size then
		cell.hp = cell.hp - self.dmg
		self.toDelete = true
		hurt1:rewind()
		hurt1:play()
		cameraShaking = true
		cameraShakeLength = cameraShakeLength + 0.3
		cameraShakeAmplitude = cameraShakeAmplitude + 5
	end
end

function EnemyBullet:draw()
	love.graphics.setColor(30, 38, 37)
	love.graphics.circle('fill', self.x, self.y, self.size)
end