require 'game'
require 'player'
require 'container'
require 'misc'
require 'bullet'
require 'bomber'
require 'sapper'
require 'anal'
require 'orbiter'
require 'enemybullet'
require 'button'
require 'architect'
require 'tiny'

function love.load()
	math.randomseed(os.time())
	love.graphics.setDefaultFilter('nearest', 'nearest', 0)
	titleImg = love.graphics.newImage('title.png')
	bulletImg = love.graphics.newImage('bullet.png')
	playerImg = love.graphics.newImage('player.png')
	playerAnim = newAnimation(love.graphics.newImage('player_anim.png'), 32, 32, 0.06, 12)
	playerHeadImg = love.graphics.newImage('head.png')
	bomberImg = love.graphics.newImage('bomber.png')
	sapperImg = love.graphics.newImage('sapper.png')
	sapperDownImg = love.graphics.newImage('sapper2.png')
	smallFont = love.graphics.newFont('1STSORTI.ttf', 21)
	hugeFont = love.graphics.newFont('1STSORTI.ttf', 80)
	gunImg = love.graphics.newImage('gun.png')
	orbiterAnim = newAnimation(love.graphics.newImage('orbiter_anim.png'), 64, 32, 0.09, 6)
	tinyImg = love.graphics.newImage('tiny.png')

	shoot1 = love.audio.newSource('shoot.ogg', 'static')
	shoot2 = love.audio.newSource('shoot2.ogg', 'static')
	shoot3 = love.audio.newSource('bul.ogg', 'static')

	hurt1 = love.audio.newSource('hurt.ogg', 'static')
	hurt2 = love.audio.newSource('hurt2.ogg', 'static')

	sap1 = love.audio.newSource('sap.ogg', 'static')

	dmg = love.audio.newSource('dmg3.ogg', 'static')

	click = love.audio.newSource('click.ogg', 'static')

	startSound = love.audio.newSource('start.ogg', 'static')
	startSound:setVolume(0.1)

	controlsImg = love.graphics.newImage('controls.png')

	fail = love.audio.newSource('fail.ogg', 'static')

	game = Game:new('Menu')
end

function love.update(dt)
	if dt > 1/30 then
		dt = 1/30
	end
	xScale = love.window.getWidth()/480
	yScale = love.window.getHeight()/360
	maxScale = math.min(xScale, yScale)
	offsetX = 240 * (xScale - maxScale)
	offsetY = 180 * (yScale - maxScale)
	game:update(dt)
end

function love.draw()
	love.graphics.push()
	love.graphics.translate(offsetX, offsetY)
	love.graphics.scale(maxScale, maxScale)
	game:draw()
	love.graphics.pop()
	love.graphics.setColor(0, 0, 0)
	love.graphics.rectangle('fill', 0, 0, offsetX, love.graphics.getHeight())
	love.graphics.rectangle('fill', love.graphics.getWidth() - offsetX, 0, offsetX, love.graphics.getHeight())
	love.graphics.rectangle('fill', 0, 0, love.graphics.getWidth(), offsetY)
	love.graphics.rectangle('fill', 0, love.graphics.getHeight() - offsetY, love.graphics.getWidth(), offsetY)
end