function love.load()
	cell = {}
	cell.x = 0
	cell.y = 0
	cell.size = 120
	cell.hp = 100

	player = {}
	player.x = 0
	player.y = -120
	player.size = 10
	player.speed = 200
	player.aimOffsetX = 0
	player.aimOffsetY = 0
	player.aimAngle = 0
	player.aimMaxOffset = 100
	player.aimSensitivity = 1

	playerBullets = {}

	hurtTimeSinceLastShot = 0
	hurtReloadTime = 0.4
	hurtSpeed = 400

	slowTimeSinceLastShot = 0
	slowReloadTime = 1.4
	slowSpeed = 250

	love.mouse.setVisible(false)
	love.mouse.setPosition(400, 300)
end

-- shit and quick
function normalize(a)
	if a < -math.pi then
		a = a + 2 * math.pi
	elseif a > math.pi then
		a = a - 2 * math.pi
	end

	return a
end

function love.update(dt)
	-- keyboard movement
	local a = math.atan2(player.y - cell.y, player.x - cell.x)
	local da = 0
	if love.keyboard.isDown('d', 'e') then
		da = player.speed / cell.size * dt
	elseif love.keyboard.isDown('a', 'q') then
		da = -player.speed / cell.size * dt
	end
	a = a + da
	a = normalize(a)
	player.x = cell.x + (cell.size + player.size) * math.cos(a)
	player.y = cell.y + (cell.size + player.size) * math.sin(a)
	player.aimOffsetX = player.aimOffsetX * math.cos(da) - player.aimOffsetY * math.sin(da)
	player.aimOffsetY = player.aimOffsetX * math.sin(da) + player.aimOffsetY * math.cos(da)

	-- mouse aim
	local dx = love.mouse.getX() - 400
	local dy = love.mouse.getY() - 300
	love.mouse.setPosition(400, 300)

	player.aimOffsetX = player.aimOffsetX + dx * player.aimSensitivity
	player.aimOffsetY = player.aimOffsetY + dy * player.aimSensitivity

	local aimOffset = math.sqrt(player.aimOffsetX^2 + player.aimOffsetY^2)
	if aimOffset > player.aimMaxOffset then
		--player.aimOffsetX = player.aimOffsetX * player.aimMaxOffset / aimOffset
		--player.aimOffsetY = player.aimOffsetY * player.aimMaxOffset / aimOffset
		aimOffset = player.aimMaxOffset
	end

	-- aim angle
	player.aimAngle = math.atan2(player.aimOffsetY, player.aimOffsetX)
	local angleDiff = a - player.aimAngle
	angleDiff = normalize(angleDiff)
	if angleDiff > math.pi/2 + 0.2 then
		player.aimAngle = a - (math.pi/2 + 0.2)
	elseif angleDiff < -(math.pi/2 + 0.2) then
		player.aimAngle = a + (math.pi/2 + 0.2)
	end
	player.aimOffsetX = aimOffset * math.cos(player.aimAngle)
	player.aimOffsetY = aimOffset * math.sin(player.aimAngle)


	-- shooting
	hurtTimeSinceLastShot = hurtTimeSinceLastShot + dt
	slowTimeSinceLastShot = slowTimeSinceLastShot + dt
	if love.mouse.isDown('l') then
		if hurtTimeSinceLastShot >= hurtReloadTime then
			hurtTimeSinceLastShot = 0
			table.insert(playerBullets, {type='hurt', x=player.x, y=player.y, vx=hurtSpeed*math.cos(player.aimAngle), vy=hurtSpeed*math.sin(player.aimAngle), size=3})
		end
	elseif love.mouse.isDown('r') then
		if slowTimeSinceLastShot >= slowReloadTime then
			slowTimeSinceLastShot = 0
			table.insert(playerBullets, {type='slow', x=player.x, y=player.y, vx=slowSpeed*math.cos(player.aimAngle), vy=slowSpeed*math.sin(player.aimAngle), size=6})
		end
	end

	-- player bullets
	for i=#playerBullets, 1, -1 do
		playerBullets[i].x = playerBullets[i].x + playerBullets[i].vx * dt
		playerBullets[i].y = playerBullets[i].y + playerBullets[i].vy * dt
	end


	if love.keyboard.isDown('escape') then
		love.event.quit()
	end
end

function love.draw()
	love.graphics.push()
	love.graphics.translate(love.graphics.getWidth()/2, love.graphics.getHeight()/2)
	love.graphics.circle('fill', cell.x, cell.y, cell.size)
	love.graphics.circle('fill', player.x, player.y, player.size)
	love.graphics.circle('fill', player.x + player.aimOffsetX, player.y + player.aimOffsetY, 1)

	for i=#playerBullets, 1, -1 do
		love.graphics.circle('fill', playerBullets[i].x, playerBullets[i].y, playerBullets[i].size)
	end
	love.graphics.pop()
	
end