local class = require 'middleclass'

Sapper = class('Sapper')

function Sapper:initialize(x, y)
	self.x = x
	self.y = y

	self.size = 6
	self.speed = 35 + math.random(15)
	local dx = cell.x - self.x
	local dy = cell.y - self.y
	local d = math.sqrt(dx^2 + dy^2)
	self.vx = dx * self.speed / d
	self.vy = dy * self.speed / d

	self.hp = 20
	self.dmg = 3

	self.toDelete = false

	self.sapping = false
end

function Sapper:update(dt)
	local dx = cell.x - self.x
	local dy = cell.y - self.y
	local d = math.sqrt(dx^2 + dy^2)
	self.vx = dx * self.speed / d
	self.vy = dy * self.speed / d

	if math.sqrt((cell.x - self.x)^2 + (cell.y - self.y)^2) < cell.size + self.size then
		cell.hp = cell.hp - self.dmg * dt
		if not self.sapping then
			sap1:rewind()
			sap1:play()
		end
		self.sapping = true
	else
		self.x = self.x + self.vx * dt
		self.y = self.y + self.vy * dt
	end

	if self.hp <= 0 then
		self.toDelete = true
		dmg:rewind()
		dmg:play()
		score = score + 40
	end
end

function Sapper:draw()
	love.graphics.setColor(30, 38, 37)
	if self.sapping then
		love.graphics.draw(sapperDownImg, self.x, self.y, math.atan2(self.vy, self.vx) - math.pi/2, 1, 1, 16, 16)
	else
		love.graphics.draw(sapperImg, self.x, self.y, math.atan2(self.vy, self.vx) - math.pi/2, 1, 1, 16, 16)
	end
end