local class = require 'middleclass'

Tiny = class('Tiny')

function Tiny:initialize(x, y)
	self.x = x
	self.y = y

	self.size = 12
	self.speed = 15 + math.random(20)
	local dx = cell.x - self.x
	local dy = cell.y - self.y
	local d = math.sqrt(dx^2 + dy^2)
	self.vx = dx * self.speed / d
	self.vy = dy * self.speed / d

	self.hp = 15
	self.dmg = 4

	self.rot = math.random() * math.pi
	self.rv = math.random() * math.pi

	self.toDelete = false
end

function Tiny:update(dt)
	local dx = cell.x - self.x
	local dy = cell.y - self.y
	local d = math.sqrt(dx^2 + dy^2)
	self.vx = dx * self.speed / d
	self.vy = dy * self.speed / d

	self.x = self.x + self.vx * dt
	self.y = self.y + self.vy * dt
	self.rot = self.rot + self.rv * dt

	if math.sqrt((cell.x - self.x)^2 + (cell.y - self.y)^2) < cell.size + self.size then
		self.toDelete = true
		cell.hp = cell.hp - self.dmg
		hurt1:rewind()
		hurt1:play()
		cameraShaking = true
		cameraShakeLength = cameraShakeLength + 0.25
		cameraShakeAmplitude = cameraShakeAmplitude + 5
	end

	if self.hp <= 0 then
		self.toDelete = true
		dmg:rewind()
		dmg:play()
		score = score + 20
	end
end

function Tiny:draw()
	love.graphics.setColor(30, 38, 37)
	love.graphics.draw(tinyImg, self.x, self.y, self.rot, 1, 1, 16, 16)
end